package net.weasel.LastCommand;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import org.bukkit.Server;
import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.event.Event.Priority;
import org.bukkit.event.player.PlayerChatEvent;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.PluginLoader;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.plugin.PluginManager;

public class LastCommand extends JavaPlugin 
{
	private final LCPlayerListener playerListener = new LCPlayerListener(this);
	private static List<String> playerList = new ArrayList<String>();
	private static List<String> commandList = new ArrayList<String>();
	public static final String DATE_FMT = "yyyy-MM-dd HH:mm:ss";
	public static String appName = null;
	
	public LastCommand(PluginLoader pluginLoader, Server instance, PluginDescriptionFile desc, File folder, File plugin, ClassLoader cLoader) 
	{
		super(pluginLoader, instance, desc, folder, plugin, cLoader);
	}

	@Override
	public void onDisable() 
	{
		logOutput("LastCommand disabled.");
	}

	@Override
	public void onEnable() 
	{
		PluginManager pm = getServer().getPluginManager();
		
		pm.registerEvent(Event.Type.PLAYER_COMMAND, this.playerListener, Priority.Normal, this);
		
		PluginDescriptionFile pdfFile = this.getDescription();
		appName = pdfFile.getName();
		logOutput( appName + " v" + pdfFile.getVersion() + " loaded.");
	}
	
	public static void sendLastCommand(PlayerChatEvent event)
	{
		Player player = event.getPlayer();
		String who = null;
		boolean found = false;
		String command = null;
		
		for( int x = 0; x < playerList.size(); x++ )
		{
			who = playerList.get(x).toString();
			
			if( who == player.getName() )
			{
				found = true;
				command = commandList.get(x);
				break;
			}
		}
		
		if( !found )
		{
			player.sendMessage( "No last command recorded." );
			event.setCancelled(true);
		}
		else
		{
			logOutput( player.getName() + " last: " + command );
			event.setMessage(command);
		}
	}
	
	public static void setLastCommand( PlayerChatEvent event )
	{
		Player player = event.getPlayer();
		String command = event.getMessage();
		
		String who = null;
		boolean found = false;
		
		for( int x = 0; x < playerList.size(); x++ )
		{
			who = playerList.get(x).toString();
			
			if( who == player.getName() )
			{
				found = true;
				commandList.set(x, command);
				break;
			}
		}
		
		if( !found )
		{
			playerList.add(player.getName());
			commandList.add(command);
		}
		else
		{
			logOutput( "Not found" );
		}
	}

	public static void logOutput(String output)
	{
		System.out.println( oH() + output );
	}
	
	public static String oH()
	{
		Calendar cal = Calendar.getInstance();
		SimpleDateFormat sdf = new SimpleDateFormat(DATE_FMT);
		return( sdf.format(cal.getTime()) + " [INFO] [" + appName + "] ");
	}
}
